//
// binary.cpp
// This program is a modification of ostrm.cpp and
// demonstrates binary file output.
// Copyright (c) Chris H. Pappas and William H. Murray, 2001
// Valid ofstream member functions include:
//         ofstream::open     ofstream::rdbuf
// Valid ostream member functions include:
//         ostream::flush     ostream::ostream
//         ostream::put       ostream::seekp
//         ostream::tellp     ostream::write

#include "stdafx.h"
#include <fstream>
#include <iostream>

using namespace std;

#define iSTRING_MAX 40

int main(int argc, char* argv[])
{
    int i = 0;
    long ltellp;
    char pszString[iSTRING_MAX] = "Sample test string\n";
    // file opened in binary mode!
    ofstream ofMyOutputStream("MYOSTRM.OUT", ios::out | ios::binary);

    // write string out character by character
    // notice that '\n' is NOT translated into 2 characters!
    while(pszString[i] != '\0') {
        ofMyOutputStream.put(pszString[i]);
        ltellp = ofMyOutputStream.tellp( );
        cout << "\ntellp value: " << ltellp;
        i++;
    }

    // write entire string out with write member function
    ltellp = ofMyOutputStream.tellp( );
    cout << "\ntellp's value before writing 2nd string: " << ltellp;
    ofMyOutputStream.write(pszString, strlen(pszString));
    ltellp = ofMyOutputStream.tellp( );
    cout << "\ntellp's updated value: " << ltellp
         << endl << endl;

    ofMyOutputStream.close( );

    return 0;
}
