//
//  clink.cpp
//  C++ program demonstrating how to link C++ code
//  to C library functions
//  Copyright (c) Chris H. Pappas and William H. Murray, 2001
//

#include "stdafx.h"
#include <iostream>   

using namespace std;

#define iMAX 9

extern "C" int imycompare(const void *pi1, const void *pi2);

int main(int argc, char* argv[])
{
    int iarray[iMAX] = { 1, 9, 2, 8, 3, 7, 4, 6, 5};

    for(int i = 0; i < iMAX; i++)
        cout << iarray[i] << " ";

    cout << endl; 

    qsort(iarray,iMAX,sizeof(int),imycompare);

    for(i = 0; i < iMAX; i++)
        cout << iarray[i] << " ";

    cout << endl << endl;

  return 0;
}

extern "C" int imycompare(const void *pi1, const void *pi2)
{
    return( *(int *)pi1 - *(int *)pi2);
}
