//
//  filbuf.cpp
//  C++ program demonstrating how to use filebuf class.
//  Copyright (c) Chris H. Pappas and William H. Murray, 2001
//
//  Valid member functions include:
//         filebuf::attach      filebuf::close
//         filebuf::fd          filebuf::~filebuf
//         filebuf::filebuf     filebuf::is_open
//         filebuf::open        filebuf::overflow
//         filebuf::seekoff     filebuf::setbuf
//         filebuf::sync        filebuf::underflow
//

#include "stdafx.h"
#include <cstdlib>       // exit() prototype
#include <fstream>       // ios::in and ios::out
#include <iostream>

//  NOTE:  use of older style header files
//     no longer used
//     #include <fcntl.h>   // _O_TEXT and _O_WRONLY
//         use ios::in and ios::out
//     #include <process.h> // exit() prototype

using namespace std;

int main(int argc, char* argv[])
{
    char ch;
    int iLineCount = 0;
    filebuf fbMyInputBuf, fbMyOutputBuf;

    fbMyInputBuf.open("filbuf.cpp", ios::in);
    if(fbMyInputBuf.is_open( ) == 0) {
        cerr << "Can't open input file";
        cout << endl << endl;
        exit (1);
    }

    istream is(&fbMyInputBuf);

    fbMyOutputBuf.open("output.dat", ios::out);
    if(fbMyOutputBuf.is_open( ) == 0) {
        cerr << "Can't open output file";
        cout << endl << endl;
        exit (2);
    }

    ostream os(&fbMyOutputBuf);

    while(is) {
        is.get(ch);
        os.put(ch);
        iLineCount += (ch == '\n');
    }

    fbMyInputBuf.close( );
    fbMyOutputBuf.close( );

    cout << "You had " << iLineCount << " lines in your file";
    cout << endl << endl;

    return 0;
}
