//
//  sqrt.cpp
//  A C++ program that prints a table of
//  numbers, squares, and square roots for the
//  numbers from 1 to 15. Program uses the type
//  double. Formatting aligns columns, pads blank
//  spaces with '0' character, and controls
//  precision of answer.
//  Copyright (c) Chris H. Pappas and William H. Murray, 2001
//

#include "stdafx.h"
#include <iostream>  
#include <iomanip>
#include <cmath>

using namespace std;

int main(int argc, char* argv[])
{
    double number, square, sqroot;

    cout << "num\t" << "square\t\t" << "square root\n";
    cout << "____________________________________\n";

    number = 1.0;
    cout.setf(ios::fixed);        // use fixed format

    for(int i = 1; i < 16; i++) {
        square = number * number; // find square
        sqroot = sqrt(number);    // find square root

        cout.fill('0');           // fill blanks with zeros
        cout.width(2);            // column 2 characters wide
        cout.precision(0);        // no decimal place
        cout << number << "\t";

        cout.width(6);            // column 6 characters wide
        cout.precision(1);        // print 1 decimal place
        cout << square << "\t\t";

        cout.width(8);            // column 8 characters wide
        cout.precision(6);        // print 6 decimal places
        cout << sqroot << endl;

        number += 1.0;
    }

    cout << endl;

    return 0;
}
